module Galactica_Arrow

using ..Ahorn, Maple

@mapdef Entity "Galactica/Arrow" Arrow(x::Integer, y::Integer, width::Integer=Maple.defaultBlockWidth, height::Integer=Maple.defaultBlockHeight)


const orientations = ["Left", "Right", "Up", "Down", "UpLeft", "UpRight", "DownLeft", "DownRight"]

const placements = Ahorn.PlacementDict(
    "Arrow ($(orientation)) (Galactica)" => Ahorn.EntityPlacement(
        Arrow,
        "rectangle",
		 Dict{String, Any}(
            "orientation" => orientation
        )
    ) for orientation in orientations
)

Ahorn.editingOptions(entity::Arrow) = Dict{String, Any}(
    "orientation" => orientations
)

function Ahorn.selection(entity::Arrow)
    x, y = Ahorn.position(entity)
    return Ahorn.getSpriteRectangle("Arrow/Left00", x, y )
end


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::Arrow, room::Maple.Room)
    orientation = get(entity.data, "orientation", "Left")
    orientation = orientation == "default" ? "Left" : orientation
    Ahorn.drawSprite(ctx,"Arrow/$(orientation)00" ,0,-1)
end

end