module Galactica_wormhole
using ..Ahorn, Maple
@mapdef Entity "Galactica/Wormhole" Wormhole(
	x::Integer, 
	y::Integer,
	width::Integer=Maple.defaultBlockWidth,
	height::Integer=Maple.defaultBlockHeight,
	SetIsID::Integer=-1,
	SetTargetID::Integer=-1,
	RequireDash::Bool=false,
	Right::Bool=false
)

const placements = Ahorn.PlacementDict(
    "Wormhole (Left) (Galactica)" => Ahorn.EntityPlacement(
        Wormhole,
        "rectangle",
	Dict{String, Any}(
            "Right" => false,
	    "RequireDash"=> false
        )
    ),
   "Wormhole (Right) (Galactica)" => Ahorn.EntityPlacement(
        Wormhole,
        "rectangle",
    	Dict{String, Any}(
            "Right" => true,
	    "RequireDash"=> false
        )
    ),
  "WormholeDash (Left) (Galactica)" => Ahorn.EntityPlacement(
        Wormhole,
        "rectangle",
    	Dict{String, Any}(
            "Right" => false,
	    "RequireDash"=> true
        )
    ),
  "WormholeDash (Right) (Galactica)" => Ahorn.EntityPlacement(
        Wormhole,
        "rectangle",
    	Dict{String, Any}(
            "Right" => true,
	    "RequireDash"=> true
        )
    )	
)


function Ahorn.selection(entity::Wormhole)
    x, y = Ahorn.position(entity)
		
    width = 25
    height = 34
    
	return Ahorn.Rectangle(x-14, y-16, width, height)
end


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::Wormhole, room::Maple.Room) 
	Right = get(entity.data, "Right", false)
	RequireDash = get(entity.data, "RequireDash", false)

	if RequireDash
		sprite = "Wormhole/WormholeDash00"
	else
		sprite = "Wormhole/Wormhole00"	
	end

   	if Right
		Ahorn.drawSprite(ctx,sprite ,46,34,rot=-pi)
    	else
		Ahorn.drawSprite(ctx,sprite ,0,0)
   	end
end

end