local drawableSprite = require("structs.drawable_sprite")

local arrow = {}

arrow.name = "Galactica/Arrow"

local orientations = {
    "Left", "Right", "Up", "Down",
    "UpLeft", "UpRight", "DownLeft", "DownRight"
}

function arrow.placements(entity)
    local placements = {}

    for i in pairs(orientations) do
        table.insert(placements, {
            name = orientations[i],
            data = {
                orientation = orientations[i]
            }
        })
    end

    return placements
end

function arrow.sprite(room, entity, viewport)
    local sprite = {}

    local sprite1 = drawableSprite.fromTexture("Arrow/" .. entity.orientation .. "00", entity)

    sprite1:addPosition(0, -1)

    table.insert(sprite, sprite1)

   return sprite
end

arrow.fieldInformation = {
    orientation = {
        options = orientations,
        editable = false
    }
}

return arrow