local drawableSprite = require("structs.drawable_sprite")

local wormhole = {}

wormhole.name = "Galactica/Wormhole"

wormhole.placements = {
    {
        name = "left",
        data = {
            SetIsID = -1,
            SetTargetID = -1,
            RequireDash = false,
            Right = false
        }
    },
    {
        name = "right",
        data = {
            SetIsID = -1,
            SetTargetID = -1,
            RequireDash = false,
            Right = true
        }
    },
    {
        name = "left_dash",
        data = {
            SetIsID = -1,
            SetTargetID = -1,
            RequireDash = true,
            Right = false
        }
    },
    {
        name = "right_dash",
        data = {
            SetIsID = -1,
            SetTargetID = -1,
            RequireDash = true,
            Right = true
        }
    }
}

wormhole.fieldInformation = {
    SetIsID = {
        fieldType = "integer"
    },
    SetTargetID = {
        fieldType = "integer"
    }
}

function wormhole.sprite(room, entity)
    local sprite = {}

    local sprite1 = drawableSprite.fromTexture("Wormhole/Wormhole00", entity)

    if entity.RequireDash then
        sprite1 = drawableSprite.fromTexture("Wormhole/WormholeDash00", entity)
    end

    if entity.Right then
        -- sprite1:addPosition(46, 34)
        sprite1.rotation = -math.pi
    end

    table.insert(sprite, sprite1)

    return sprite
end

return wormhole